#version 330

//action id as color
uniform float action_id;

uniform mat4 model_matrix;
uniform mat4 view_matrix;
uniform mat4 projection_matrix;

// position and normal vector (model space)
in vec3 p_model;
in vec3 n_model;

// varyings (camera space)
out vec3 n_camera; // normalized!

void main(void)
{
	mat4 MV = view_matrix * model_matrix;
	mat4 MVP = projection_matrix * MV;

	gl_Position = MVP * vec4(p_model, 1.0);

	// surface normal (camera space)
	n_camera = normalize((MV * vec4(n_model, 0.0)).xyz);
}